package wdp_dicon;

import junit.framework.TestCase;
import wdp.FileAccessor;
import wdp.FileAccessorImp;
import wdp.FileScanner;
import wdp_di2.FileScannerImpDi2;
import wdp_di2.Matcher;
import wdp_di2.MatcherImp;
import wdp_dicon.SimpleDiContainer.Inject;

public class SimpleDiContainerTest extends TestCase {

	public void testInject() throws Exception {
		
		SimpleDiContainer container = SimpleDiContainer.getInstance();
		container.register(FileScanner.class, 
				container.new Bean(FileScannerImpDi2.class, 
						new Inject[]{
							container.new Inject("setAccessor", FileAccessor.class), 
							container.new Inject("setMatcher", Matcher.class)}));
		container.register(FileAccessor.class, 
				container.new Bean(FileAccessorImp.class, 
						new Inject[]{}));
		container.register(Matcher.class, 
				container.new Bean(MatcherImp.class, 
						new Inject[]{}));
		
		FileScanner scanner = (FileScanner)container.lookup(FileScanner.class);
		assertEquals("a1\na4\n", scanner.scan("wdp/test.txt"));
		
	}
	
}
